<template>
	<view class="">
		<view class="m-card m-address">
			<view class="address-info" @click="showAddress = true" v-if='orderInfo.shipping_type==1'>
				<view class="top">
					<up-icon name="account"></up-icon>
					<view class="t-name">{{addressInfo.real_name}}</view>
					<view>{{addressInfo.phone}}</view>
				</view>
				<view class="bottom u-line-2">
					{{addressInfo.detail}}
				</view>
			</view>
			<view class="address-info" v-else>
				<view class="top">
					{{STORE_INFO.name}}
				</view>
				<view class="bottom u-line-2">
					{{STORE_INFO.detailed_address}}
				</view>
			</view>
			<view class="address-btn item-center">
				<view class='ship-type' style="">
					<view class="ship-type-item" :class='{actShipItem:orderInfo.shipping_type==2 }'
						@click='orderInfo.shipping_type=2'>
						自提
					</view>
					<view class="ship-type-item" @click='orderInfo.shipping_type=1'
						:class='{actShipItem:orderInfo.shipping_type==1 }' v-if='orderInfo.default_delivery==1'>
						配送
					</view>
				</view>
			</view>
		</view>
		<view class="m-card m-good" v-for="(item,index) in cartList" :key="index">
			<view class="image">
				<up-image width="160rpx" height="160rpx" :src="item.imgs"></up-image>
			</view>
			<view class="body-content">
				<view>
					<view class="title">
						<view>{{item.name}}</view>
						<view>¥{{item.price}}</view>
					</view>
					<view class="tips">
						<view>{{item.unit_name}}</view>
						<view>x{{item.cart_num}}</view>
					</view>
				</view>
				<view class="time">
					{{orderInfo.delivery_msg}}
				</view>
			</view>
		</view>
		<view class="m-card good-info">
			<view class="head-title">价格明细</view>
			<view class="row">
				<view>商品总价 <text>共计{{cartList.length}}款商品</text></view>
				<view>
					<text>¥</text>{{c_price(orderInfo.total_price, 0)}}<text>.{{c_price(orderInfo.total_price, 1)}}</text>
				</view>
			</view>
			<view class="row">
				<view>运费</view>
				<view><text>¥</text>0<text>.00</text></view>
			</view>
			<view class="row" v-if="orderInfo.activities==1" style="color: red;">
				<view>活动折扣 <text>{{orderInfo.activity}}</text></view>
				<view>
					-¥<text>{{orderInfo.activity_price}}</text>
				</view>
			</view>
		</view>
		<view class="m-card good-info">
			<view class="head-title">支付方式</view>
			<view class="row">
				<view class="icon-text">
					<up-icon name="weixin-circle-fill" color="#20b128" size="22"></up-icon>
					<text style="margin-left: 20rpx;font-size: 26rpx;">微信支付</text>
				</view>
				<view class="icon" @click="onChoosePaytype(7)">
					<image v-if="pay_type == 7" src="@/static/icon/check.png" />
					<image v-if="pay_type != 7 || pay_type == 3 || !pay_type" src="@/static/icon/n-check.png" />
				</view>
			</view>

			<view class="row">
				<view class="icon-text">
					<image src="@/static/icon/YEZF.png" style="width:40rpx;height: 40rpx;" />
					<text style="margin-left: 20rpx;font-size: 26rpx;">余额支付</text>
				</view>
				<view class="icon" @click="onChoosePaytype(3)">
					<image v-if="pay_type == 3" src="@/static/icon/check.png" />
					<image v-if="pay_type != 3 || pay_type == 1 || !pay_type" src="@/static/icon/n-check.png" />
				</view>
			</view>
		</view>

		<!-- <view class="m-card order-remark">
			<view class="head-title">
				<text>预约时间</text>
			</view>
			<uni-datetime-picker type="date" :clear-icon="false" v-model="reservation_time" />
		</view> -->

		<view class="m-card order-remark">
			<view class="head-title">
				<text>订单备注</text>
				<text>0/200</text>
			</view>
			<up-textarea style="background-color: #F6F6F6;" v-model="formData.remark" placeholder="暂无备注内容"
				:height="40"></up-textarea>
		</view>
		<view style="width: 100%;height: 200rpx;"></view>
		<view class="fiexd-btn-box" style="z-index: 999;">
			<view class="tips">
				<view style="margin-right: 20rpx;">共 {{ cartList.length }} 款</view>
				<view class="all">
					<text style="color: #000;">合计: </text>
					<text>￥</text>
					<block v-if="orderInfo.total_price">
						<text style="font-size: 32rpx;font-weight: bold;">{{c_price(orderInfo.pay_price, 0)}}</text>
						<text>.{{c_price(orderInfo.pay_price, 1)}}</text>
					</block>
				</view>
			</view>
			<view style="width: 200rpx;">
				<up-button color="#20B128" shape="circle" @click="submitOrder" :throttleTime="1000">预付款提交</up-button>
			</view>
		</view>

		<addressPopup ref="addressRef" :show="showAddress" :list="addressList" @close="showAddress=false"
			@change="changeAddress" />
		<shopListPopupVue ref="shopRef" :show="shopListShow" :list="merchantList" @close="shopListShow=false"
			@change="changeShop" @search="searchShop" />
		<modal title="尚未设置收货地址" content="您还没有添加收货地址，请点击添加" cancleText="添加地址" confirmText="继续支付" :show="toastAddressShow"
			@close="addAddress" @change="goPay" />
		<!-- <modal title="是否要拨打电话" :content="`即将拨打电话${phone}`" cancleText="取消" confirmText="拨打" :show="callShow" @close="callShow = false"
      @change="onCall" /> -->
	</view>
</template>

<script setup>
	import {
		onLoad,
		onShow
	} from "@dcloudio/uni-app"
	import {
		nextTick,
		ref
	} from "vue"
	import addressPopup from "@/components/addressPopup.vue";
	import shopListPopupVue from "@/components/shopListPopup.vue";
	import useCartStore from "@/store/cart.js";
	import modal from "@/components/modal.vue";
	import {
		checkOrderApi
	} from "@/api/cart.js";
	import {
		addressListsApi,
		merchantListApi
	} from "@/api/user.js";
	import {
		createOrderApi
	} from "@/api/order.js";

	//  用户选择的门店信息
	let STORE_INFO = uni.getStorageSync('STORE_INFO');
	if (STORE_INFO)
		STORE_INFO = JSON.parse(STORE_INFO)

	const cartStore = useCartStore();
	const reservation_time = ref('')

	const formData = ref({
		remark: ""
	})

	const isAddress = ref(false);
	const toastAddressShow = ref(false);

	const onChoosePaytype = (e) => {
		pay_type.value = e;
	}

	// 选择地址
	const addressRef = ref(null);
	const showAddress = ref(false);
	const addressInfo = ref({});
	const changeAddress = (e) => {
		addressInfo.value = e;
		showAddress.value = false;
		isAddress.value = true;
	}
	const openAddress = () => {
		if (addressList.length > 0) showAddress.value = true;
		else uni.navigateTo({
			url: '/pagesOrder/addressEdit/addressEdit'
		})
	}

	// 地址相关
	const addressList = ref([]);
	const getAddressList = () => {
		addressListsApi().then(res => {
			addressList.value = res.data.lists;
			addressList.value.forEach(item => {
				if (item.is_default) {
					addressInfo.value = item;
					isAddress.value = true;
				}
			})
			if (!isAddress.value && addressList.value.length > 0) {
				addressInfo.value = addressList.value[0];
				isAddress.value = true;
			}
			if (addressInfo.value.address_id) {
				nextTick(() => {
					addressRef.value.setCheck(addressInfo.value.address_id);
				})
			}
		})
	}

	// 提货点相关
	const shopRef = ref(null);
	const shopListShow = ref(false);
	const merchantList = ref([]);
	const myAddressInfo = ref({
		long: "",
		lat: ""
	})
	const shopInfo = ref({
		mer_id: ''
	});

	const getMerchantList = (mer_name = null) => {
		merchantListApi({
			...myAddressInfo.value,
			mer_name: mer_name ? mer_name : ''
		}).then(res => {
			merchantList.value = res.data.lists;
			if (mer_name === null && myAddressInfo.value.long && merchantList.value.length > 0 && !shopInfo
				.value.mer_id) {
				shopInfo.value = merchantList.value[0];
				shopInfo.value.recommend = 1;
				nextTick(() => {
					shopRef.value.setCheck(shopInfo.value.mer_id);
				})
			}
		})
	}

	// getMerchantList();
	// 定位
	const LoadAddress = () => {
		uni.getLocation({
			success: (res) => {},
			fail: (err) => {
				uni.$u.toast('定位失败, 请手动选择提货点!')
			},
			complete: (res) => {
				myAddressInfo.value.long = res.longitude || "";
				myAddressInfo.value.lat = res.latitude || "";
				getMerchantList();
			}
		})
	}
	// LoadAddress();

	const changeShop = (e) => {
		shopInfo.value = e;
		shopListShow.value = false;
	}
	const searchShop = (e) => {
		getMerchantList(e)
	}

	// 拨打电话
	// const callShow = ref(false)
	// const phone = ref('');
	// const callphone = (e) => {
	//   callShow.value = true;
	//   phone.value = e;
	// }
	const onCall = (e) => {
		uni.makePhoneCall({
			phoneNumber: e,
			success() {
				callShow.value = false
			}
		})
	}

	// 选择地址
	const addAddress = () => {
		toastAddressShow.value = false;
		nextTick(() => {
			showAddress.value = true;
		})
	}
	// 继续支付
	const goPay = () => {
		toastAddressShow.value = false;
		isAddress.value = true;
		submitOrder();
	}

	// 提交订单
	const submitOrder = () => {
		// if (!shopInfo.value.mer_id) {
		//   uni.$u.toast('请先选择提货点');
		//   return shopListShow.value = true;
		// }
		if (!isAddress.value && orderInfo.value.shipping_type == 1) return toastAddressShow.value = true;
		createOrder();
	}
	// 订单相关
	const cartList = ref([]);
	const orderInfo = ref({});
	const checkOrder = () => {
		checkOrderApi({
			cart_id: cartStore.cartList,
			store_id: STORE_INFO.id || 0
		}).then(res => {
			cartList.value = res.data.cart_list;
			orderInfo.value = res.data.order;
			if (orderInfo.value.default_delivery == 0) {
				orderInfo.value.shipping_type = 2
			}
		})
	}

	const pay_type = ref('');

	const createOrder = () => {
		if (!pay_type.value) return uni.$u.toast('请选择支付方式');

		createOrderApi({
			cart_id: cartStore.cartList,
			address_id: addressInfo.value.address_id,
			pay_type: pay_type.value,
			store_id: STORE_INFO.id || 0,
			reservation_time: reservation_time.value,
			shipping_type: orderInfo.value.shipping_type,
			mark: formData.value.remark

		}).then(res => {
			console.log(res);
			if (pay_type.value == 3) {
				if (res.code == 1) {
					uni.showToast({
						title: res.msg,
						icon: "none",
						success() {
							setTimeout(() => {
								uni.redirectTo({
									url: '/pagesOrder/order/order?back=-1&type=2'
								})
							}, 1500)
						}
					})
				} else {
					uni.$u.toast(res.msg);
				}
			} else {
				if (!res.data?.nonceStr) return uni.$u.toast('支付失败!');
				uni.requestPayment({
					provider: 'wxpay',
					timeStamp: res.data.timeStamp,
					nonceStr: res.data.nonceStr,
					package: res.data.package,
					signType: res.data.signType,
					paySign: res.data.paySign,
					success: (e) => {
						if (e.errMsg == 'requestPayment:ok') {
							uni.showModal({
								title: '订单支付成功',
								confirmText: '查看订单',
								cancelText: '继续购买',
								success: (e) => {
									if (e.confirm) uni.redirectTo({
										url: '/pagesOrder/order/order?back=-1&type=2'
									})
									else uni.navigateBack();
								}
							})
						} else uni.$u.toast('支付失败')
					},
					fail: (e) => {
						uni.$u.toast('用户取消支付');
						uni.redirectTo({
							url: '/pagesOrder/order/order?back=-1&type=1'
						})
					}
				})
			}
		}).catch(err => {
			uni.$u.toast(err.msg || '网络错误')
		})
	}

	const c_price = (price, index = 0) => {
		price = price + '';
		return price.split('.')[index] || (index ? '00' : '0');
	}

	onLoad(options => {
		checkOrder();
	})
	onShow(() => {
		getAddressList();
	})
</script>

<style lang="scss">
	.m-card {
		margin: 20rpx;
		border-radius: 14rpx;
		background-color: #fff;
		padding: 20rpx;
	}

	.row {
		padding: 0;
		overflow: hidden;
	}

	.m-address {
		margin-bottom: 20rpx;
		display: flex;
		justify-content: space-between;
		color: #999999;

		.address-info {
			width: 450rpx;

			.top {
				display: flex;
				font-size: 28rpx;

				.t-name {
					color: #444;
					margin: 0 10rpx;
				}
			}

			.bottom {
				font-size: 24rpx;
			}
		}
	}

	.m-good {
		display: flex;
		justify-content: space-between;
		margin-bottom: 20rpx;

		.image {
			width: 160rpx;
			height: 160rpx;
			margin-right: 20rpx;
			border-radius: 14rpx;
			overflow: hidden;
		}

		.body-content {
			width: 490rpx;
			display: flex;
			flex-direction: column;
			justify-content: space-between;
			color: #989898;

			.title {
				display: flex;
				justify-content: space-between;
				font-size: 28rpx;
				color: #444;
			}

			.tips {
				display: flex;
				justify-content: space-between;
				font-size: 24rpx;
				margin-top: 10rpx;
			}

			.time {
				background-color: #F6F6F6;
				padding: 5rpx 10rpx;
				font-size: 26rpx;
				color: #444;
				border-radius: 10rpx;
			}
		}
	}

	.good-info {
		margin-bottom: 20rpx;

		.head-title {
			margin-bottom: 18rpx;
			color: #000;
			font-weight: bold;
		}

		.row {
			display: flex;
			align-items: center;
			justify-content: space-between;
			margin-bottom: 18rpx;

			.red {
				color: #F55726;
			}

			.icon-text {
				display: flex;
				align-items: center;
			}

			.icon {
				image {
					width: 40rpx;
					height: 40rpx;
				}
			}
		}

		.row-need {
			display: flex;
			justify-content: flex-end;
			color: #F55726;
		}

		text {
			font-size: 22rpx;
		}
	}

	.order-remark {
		.head-title {
			margin-bottom: 18rpx;
			display: flex;
			justify-content: space-between;
		}
	}

	.tips {
		font-size: 28rpx;
		color: #999;
		display: flex;
		justify-content: flex-end;
		align-items: center;
		flex: 1;
		margin-right: 20rpx;

		.all {
			color: #F55726;
		}
	}

	.item-center {
		display: flex;
		align-items: center;
		position: relative;
	}

	.ship-type {
		display: flex;
		z-index: 9;
		background-color: #F6F6F6;
		border-radius: 30rpx;

		.ship-type-item {
			width: 82rpx;
			height: 54rpx;
			line-height: 54rpx;
			text-align: center;
			transition: background-color 0.3s ease;
			border-radius: 30rpx;
		}

		.actShipItem {
			background-color: #27B52F;
			color: white;
		}
	}
</style>